ConvNavToPx proc Lat:real8,Long:real8,pLeft:dword,pTop:dword
	LOCAL index[3]:dword
	LOCAL left:dword
	LOCAL top:dword
	LOCAL scaleX:real8
	LOCAL scaleY:real8
	LOCAL ScaleFactor:real8
	
	;Touching the stack frame 
	mov eax,ebp 
	.while eax>esp 
		dec eax
		mov byte ptr [eax],0 
	.endw 
	
	push esi
	push edi
	push edx
	
	;Find nearast ref point index and scaleX and scaleY
	invoke FindThreeRefPointsLL,Lat,Long,addr index
	invoke CalculateLatDistortion,Lat,addr index,addr ScaleFactor
	invoke CalculateScaleY,addr index,addr scaleY,ScaleFactor
	invoke CalculateScaleX,addr index,addr scaleX
	
	mov edi,pREF
	add edi,4
	mov eax,index
	mov ecx,sizeof REF
	mul ecx
	add edi,eax
	
	finit
	fld Lat
	fsub dword ptr [edi].REF.lat
	fmul scaleY
	fchs
	fiadd dword ptr [edi].REF.top
	fmul zoomFactor
	frndint
	fistp top
	fwait
	
	finit
	fld Long 
	fld dword ptr  [edi].REF.long
	fsub
	fmul scaleX
	fiadd dword ptr [edi].REF.left
	fmul zoomFactor
	frndint
	fistp left
	fwait
	
	mov edx,pTop
	mov eax,top
	mov dword ptr [edx],eax
	mov edx,pLeft
	mov eax,left
	mov dword ptr [edx],eax
	
	pop edx
	pop edi
	pop esi
	
	ret
	
ConvNavToPx endp

FindThreeRefPointsLL proc Lat:real8,Long:real8,pIndex:dword
	LOCAL cPoints:dword
	LOCAL deltaLat:real8
	LOCAL deltaLong:real8
	LOCAL count:dword
	LOCAL dist:real8
	LOCAL integer:dword
	LOCAL hor:dword
	LOCAL ver:dword
	
	;Touching the stack frame 
	mov eax,ebp 
	.while eax>esp 
		dec eax
		mov byte ptr [eax],0 
	.endw 
	
	push esi
	push edi
	push edx
	
	;Fill indexarray with 0FFFFFFFFh
	mov edi,pIndex
	mov ecx,3
	mov eax,-1
	rep stosd
	
	mov eax,pREF
	mov eax,dword ptr [eax] ;Number of refpoints
	mov cPoints,eax
	.if eax==3
		mov edi,pIndex
		mov dword ptr [edi],0
		mov dword ptr [edi+4],1
		mov dword ptr [edi+8],2
		
		jmp @Exit
	.endif
	
	;Find the three nearast refpoints
	xor ebx,ebx
	.while ebx<3
		push ebx
		
		finit
		mov integer,5000
		fild integer
		fstp dist
	
		mov esi,pIndex
		
		mov edi,pREF
		add edi,4 ;first refpoint
		
		xor ecx,ecx
		.while ecx<cPoints
			push ecx
			mov count,ecx
			mov edx,ecx
			
			;check if point is allready found
			xor ecx,ecx
			.while ecx<ebx
				.if dword ptr [esi+ecx*4]==edx
					jmp @F
				.endif
				inc ecx
			.endw
			
			;Check if refpoint 1 and two are aligned horizontally or vertically
			.if ebx==2
				push edi ;Store pointer to current refpoint to examine
				mov edi,pREF
				add edi,4
				.if cPoints==4
					nop
				.endif
				;Horizontally?
				mov eax,dword ptr [esi]
				mov ecx,sizeof REF
				mul ecx
				mov eax,dword ptr [edi+eax].REF.left
				mov hor,eax
				push eax
				mov eax,dword ptr [esi+4]
				mov ecx,sizeof REF
				mul ecx
				mov ecx,dword ptr [edi+eax].REF.left
				pop eax
				sub eax,ecx
				invoke crt_abs,eax
				push eax ;Store horizontal difference between refpoints 1 and 2
				
				;Vertically?
				mov eax,dword ptr [esi]
				mov ecx,sizeof REF
				mul ecx
				mov eax,dword ptr [edi+eax].REF.top
				mov ver,eax
				push eax
				mov eax,dword ptr [esi+4]
				mov ecx,sizeof REF
				mul ecx
				mov ecx,dword ptr [edi+eax].REF.top
				pop eax
				sub eax,ecx
				invoke crt_abs,eax
				pop ecx ;Restore horizontal difference between refpoints 1 and 2
				
				pop edi ;Retore pointer to current refpoint to examine
				
				push eax ;Store vertical difference between refpoints 1 and 2
				push ecx ;Store horizontal difference between refpoints 1 and 2
				
				mov edx,dword ptr [edi].REF.left
				sub hor,edx
				invoke crt_abs,hor
				mov hor,eax
				mov edx,dword ptr [edi].REF.top
				sub ver,edx
				invoke crt_abs,ver
				mov ver,eax
				
				pop ecx ;Restore horizontal difference between refpoints 1 and 2
				pop eax ;Restore vertical difference between refpoints 1 and 2
				
				.if eax>ecx
					;Vertically refpoints 1 and 2
					mov eax,hor
					.if ver>eax
						;Third refpoint is also vertical. Not accepted
						jmp @F
					.endif
				.elseif eax<ecx
					;Horizontally refpoints 1 and 2
					mov eax,ver
					.if hor>eax
						;Third refpoint is also horizontal. Not accepted
						jmp @F
					.endif
				.endif
				
			.endif
			
			finit
			fld dword ptr [edi].REF.lat
			fsub Lat
			fst deltaLat
			fmul deltaLat
			fld dword ptr [edi].REF.long
			fsub Long
			fst deltaLong
			fmul deltaLong
			fadd
			fcom dist
			fstsw ax
			fwait
			sahf
			ja @F
				fstp dist
				fwait
				mov eax,count ;dword ptr [edi].REF.index
				mov dword ptr [esi+ebx*4],eax
	@@:		fwait
			add edi,sizeof REF
			
			pop ecx
			inc ecx
		.endw
		
		pop ebx
		inc ebx
	.endw
	
@Exit:
	pop edx
	pop edi
	pop esi

	ret

FindThreeRefPointsLL endp

CalculateScaleY proc pIndex:dword,pScaleY:dword,ScaleFactor:real8
	LOCAL deltaY:dword
	LOCAL refLat1:real8
	LOCAL scaleY:real8
	
	;Touching the stack frame 
	mov eax,ebp 
	.while eax>esp 
		dec eax
		mov byte ptr [eax],0 
	.endw 
	
	push esi
	push edi
	push edx
	
	;Calculate scaleY
	mov edi,pREF
	add edi,4 ;first refpoint
	mov esi,pIndex
	mov eax,dword ptr [esi]
	mov ecx,sizeof REF
	mul ecx
	mov ecx,dword ptr [edi+eax].REF.top
	mov deltaY,ecx
	
	fld dword ptr [edi+eax].REF.lat
	fst refLat1
	fld dword ptr [edi+eax].REF.lat
	mov eax,dword ptr [esi+4]
	mov ecx,sizeof REF
	mul ecx
	fsub dword ptr [edi+eax].REF.lat ;diff nearast lat and second nearast
	fabs
	fxch st(1)
	mov eax,dword ptr [esi+8]
	mov ecx,sizeof REF
	mul ecx
	fsub dword ptr [edi+eax].REF.lat ;diff nearast lat and third nearast
	fabs
	fcom
	fstsw ax
	fwait
	sahf
	jbe @F
		mov eax,dword ptr [esi+8]
		mov ecx,sizeof REF
		mul ecx
		jmp @1
@@:	fxch
	mov eax,dword ptr [esi+4]
	mov ecx,sizeof REF
	mul ecx
	
@1:	mov eax,dword ptr [edi+eax].REF.top
	sub deltaY,eax
	
	fild deltaY
	fxch
	fdiv
	fabs
	fmul ScaleFactor
	fstp scaleY
	
	lea esi,scaleY
	mov edi,pScaleY
	mov ecx,2
	rep movsd
	
	pop edx
	pop edi
	pop esi

	ret

CalculateScaleY endp

CalculateScaleX proc pIndex:dword,pScaleX:dword
	LOCAL deltaX:dword
	LOCAL scaleX:real8
	
	;Touching the stack frame 
	mov eax,ebp 
	.while eax>esp 
		dec eax
		mov byte ptr [eax],0 
	.endw 
	
	push esi
	push edi
	push edx
	
	;Calculate scaleX
	mov edi,pREF
	add edi,4 ;first refpoint
	mov esi,pIndex
	mov eax,dword ptr [esi]
	mov ecx,sizeof REF
	mul ecx
	mov ecx,dword ptr [edi+eax].REF.left
	mov deltaX,ecx
	
	fld dword ptr [edi+eax].REF.long
	fld dword ptr [edi+eax].REF.long
	mov eax,dword ptr [esi+4]
	mov ecx,sizeof REF
	mul ecx
	fsub dword ptr [edi+eax].REF.long ;diff nearast lag and second nearast
	fabs
	fxch st(1)
	mov eax,dword ptr [esi+8]
	mov ecx,sizeof REF
	mul ecx
	fsub dword ptr [edi+eax].REF.long ;diff nearast lag and third nearast
	fabs
	fcom
	fstsw ax
	fwait
	sahf
	jbe @F
		mov eax,dword ptr [esi+8]
		mov ecx,sizeof REF
		mul ecx
		jmp @2
@@:	fxch
	mov eax,dword ptr [esi+4]
	mov ecx,sizeof REF
	mul ecx
	
@2:	mov eax,dword ptr [edi+eax].REF.left
	sub deltaX,eax
	neg deltaX
	fild deltaX
	fxch
	fdiv
	fabs
	fstp scaleX
	
	lea esi,scaleX
	mov edi,pScaleX
	mov ecx,2
	rep movsd
	
	
	pop edx
	pop edi
	pop esi
	
	ret
	
CalculateScaleX endp

CalculateLatDistortion proc Lat:real8,pIndex:dword,pScaleFactor:dword
	LOCAL ScaleFactor:real8
	LOCAL refLat1:real8
	LOCAL refLat2:real8
	LOCAL refLat3:real8
	LOCAL integer:dword
		
	;Touching the stack frame 
	mov eax,ebp 
	.while eax>esp 
		dec eax
		mov byte ptr [eax],0 
	.endw 
	
	push esi
	push edi
	push edx
	
	finit
	fld1
	fstp ScaleFactor
	
	mov edi,pREF
	add edi,4
	
	mov esi,pIndex
	mov eax,dword ptr [esi]
	mov ecx,sizeof REF
	mul ecx
	finit
	fldpi
	fmul dword ptr [edi+eax].REF.lat
	mov integer,180
	fidiv integer
	fstp refLat1 ;nearast lat in radians
	
	mov eax,dword ptr [esi+4]
	mov ecx,sizeof REF
	mul ecx
	fldpi
	fmul dword ptr [edi+eax].REF.lat
	mov integer,180
	fidiv integer
	fstp refLat2 ;second lat in radians
	
	mov eax,dword ptr [esi+8]
	mov ecx,sizeof REF
	mul ecx
	fldpi
	fmul dword ptr [edi+eax].REF.lat
	mov integer,180
	fidiv integer
	fstp refLat3 ;third lat in radians
	
	;Check which distance i the larges, to 2 och 3
	finit
	fld refLat3
	fsub refLat1
	fabs
	fld refLat2
	fsub refLat1
	fabs
	
	fcomp
	fstsw ax
	sahf
	jae @F
		;refLat3 is located further away from refLat1 than refLat2 do
		;swap refpoint values
		fld refLat3
		fstp refLat2
@@:	
	
	;calculate ln(tan(45+refLat2/2)
	finit
	fld refLat2
	mov integer,2
	fidiv integer
	fldpi
	mov integer,4
	fidiv integer
	fadd
	fptan
	fstp st
	fldln2
	fxch st(1)
	fyl2x ;kLat2 = ln(tan(45 + refLat2 / 2) =+1.305380580484128
	
	;calculate ln(tan(45+refLat1/2)
	fld refLat1
	mov integer,2
	fidiv integer
	fldpi
	mov integer,4
	fidiv integer
	fadd
	fptan
	fstp st
	fldln2
	fxch st(1)
	fyl2x ;kLat1 = ln(tan(45 + refLat1 / 2) =+1.2939176754447657
	fst st(2)
	
	fsub
	fabs ;=abs(kLat2 -kLat1) =+0.011462905039362846
	fxch
	
	;calculate ln(tan(45+Lat/2)
	fldpi
	fmul Lat
	mov integer,180
	fidiv integer
	mov integer,2
	fidiv integer
	fldpi
	mov integer,4
	fidiv integer
	fadd
	fptan
	fstp st
	fldln2
	fxch st(1)
	fyl2x ;kLat = ln(tan(45 + Lat / 2) =+1.2966331031049930
	
	fsub
	fabs ;=abs(kLat -kLat1) =+0.0027154276602273292
	
	fxch
	fdiv ;k1 = abs(kLat2 -kLat1) / abs(kLat -kLat1) =+0.23688826269630019
	
	fldpi
	fmul Lat
	mov integer,180
	fidiv integer
	fsub refLat1
	fabs ; abs(Lat - Lat1) =+0.0013833671905513833
	
	fld refLat2
	fsub refLat1
	fabs ;abs(Lat2 - Lat1) =+0.0058178085593327821
	fdiv ;k2 = abs(Lat2 - Lat1) / abs(Lat - Lat1) =+0.23778149047758205
	fdiv ;k2 / k1
	fstp ScaleFactor ;=+0.99624349321939305
		
	lea esi,ScaleFactor
	mov edi,pScaleFactor
	mov ecx,2
	rep movsd
	
	pop edx
	pop edi
	pop esi

	ret

CalculateLatDistortion endp

;LatScaleFactor is not used
LatScaleFactor proc Lat1:real8,Lat2:real8,pFactor:dword
	LOCAL integer:dword
	
	;Touching the stack frame 
	mov eax,ebp 
	.while eax>esp 
		dec eax
		mov byte ptr [eax],0 
	.endw 
	
	push esi
	push edi
	push edx
	
	;Factor = 1 - ln{[tan(Lat1)+sec(Lat1)]/[tan(Lat2)+sec(Lat2)]} = 
	;= 1 - ln{[tan(Lat1)+2/(eLat1+e-Lat1)]/[tan(Lat2)+2/eLat2+e-Lat2)]}
	
	;Convert Lat1 deg to rad
	finit
	fldpi
	lea edi,Lat1
	fmul qword ptr [edi]
	mov integer,180
	fidiv integer
	fld st
	fld st
	
	;Calculate e^Lat1
	fldl2e 
	fmul
	fld st
	frndint
	fsub st(1),st
	fxch st(1)
	f2xm1
	fld1
	fadd
	fscale
	fstp st(1)
	
	fxch st(1)
	
	;Calculate e^-Lat1
	fchs
	fldl2e 
	fmul
	fld st
	frndint
	fsub st(1),st
	fxch st(1)
	f2xm1
	fld1
	fadd
	fscale
	fstp st(1)
	
	;Calculate 2/(e^Lat1+e^-Lat1)
	fadd
	mov integer,2
	fild integer
	fxch st(1)
	fdiv
	
	;Calculate tan(Lat1)+sec(Lat1)
	fxch st(1)
	fptan
	fstp st
	fadd
	
	;Convert Lat2 deg to rad
	fldpi
	lea edi,Lat2
	fmul qword ptr [edi]
	mov integer,180
	fidiv integer
	fld st
	fld st
	
	;Calculate e^Lat2
	fldl2e 
	fmul
	fld st
	frndint
	fsub st(1),st
	fxch st(1)
	f2xm1
	fld1
	fadd
	fscale
	fstp st(1)
	
	fxch st(1)
	
	;Calculate e^-Lat2
	fchs
	fldl2e 
	fmul
	fld st
	frndint
	fsub st(1),st
	fxch st(1)
	f2xm1
	fld1
	fadd
	fscale
	fstp st(1)
	
	;Calculate 2/(e^Lat2+e^-Lat2)
	fadd
	mov integer,2
	fild integer
	fxch st(1)
	fdiv
	
	;Calculate tan(Lat2)+sec(Lat2)
	fxch st(1)
	fptan
	fstp st
	fadd
	
	;Divide tan(Lat1)+sec(Lat1) with tan(Lat2)+sec(Lat2)
	fxch st(1)
	fdiv
	
	;Calculate ln of division
	fldln2
	fxch st(1)
	fyl2x
	
	;Calculate scalefactor
	fld1
	fadd
	
	mov edi,pFactor
	fstp qword ptr [edi]
	
	
	
	pop edx
	pop edi
	pop esi
	
	ret

LatScaleFactor endp

